题目
解答
我的答案
- 思路
暴力循环,从数组第一个出发,依次跟后面的数进行相加判断
- 代码
class Solution {
public int[] twoSum(int[] nums, int target) {
// 循环第一层
for (int i = 0; i < nums.length; i++) {
// 循环第二层,从j=i+1开始
for (int j = i + 1; j < nums.length; j++) {
// 判断相加是否符合target
if(nums[i] + nums[j] == target){
// 找到就返回下标数组
return new int[]{i, j};
}
}
}
// 否则返回空数组
return new int[0];
}
}
- 分析
两次for循环时间复杂度为O(n^2)
空间复杂度为O(1)
- 结果
官方答案
- 思路
利用hashmap表存target-nums[i]的结果为key,下标为value。遍历时,判断当前的target-nums[i]是否在hash表中,有就找到,取对应的下标值,没有就存入hashmap中。
- 代码
class Solution {
public int[] twoSum(int[] nums, int target) {
// 新建一个hashmap,key为target-x,value为当前数组的下标
Map<Integer, Integer> hashtable = new HashMap<Integer, Integer>();
// 第一次循环
for (int i = 0; i < nums.length; ++i) {
// 判断当前的hashmap中是否存在target-x的key,有就找到了,返回下标数组即可
if (hashtable.containsKey(target - nums[i])) {
return new int[]{hashtable.get(target - nums[i]), i};
}
// 没找到,就将当前的target-x存入
hashtable.put(nums[i], i);
}
// 没有则返回空数组
return new int[0];
}
}
- 分析
时间复杂度:O(N),其中 NN是数组中的元素数量。利用hashmap消除一个for循环去寻找 满足x+y= target 的y。
空间复杂度:O(N),增加一个长度为N的hashmap
- 结果
大佬的解答
暂无(有建议的欢迎提出来,让大家学习学习)
额外知识
看大家的评论发现一个解答使用了containsValue去找结果,结果评论提出containsKey的速度比containsValue高很多,因为containsKye底层用hash去查找,而containsValue通过遍历value寻找。